import pyglet, os, data
from pyglet.window import key
from pyglet.gl import *
pyglet.options['audio'] = ("openal","directsound","silent")

##functions
def collide(f,b):
    return (-21<=f.pos[0]-b.pos[0]<=21 and -19<=f.pos[1]-b.pos[1]<=19)


def toVert((x,y),(w,h),extra=False):

    verts =(x-w,y+h,
            x-w,y-h,
            x+w,y-h,
            x+w,y+h)
            
    if extra:
        verts =(x-w,y+h,
            x-w,y-h,
            x+w,y-h,
            x+w,y+h,
            x-w,y+h,)

    return list(verts)

def toGrid(x,y):
    offset=200-15,480+15
    return offset[0]+30*x,offset[1]-30*y









##classes
class feather:#FIX add a reset button
    def __init__(self,batch,group,image,image2,xy):
        self.pos=list(xy)
        self.rad=[7,4]
        self.vel=[0,0]
        self.gravity=-0.05
        self.img=image
        self.img2=image2
        self.dir=0
        self.sprite=pyglet.sprite.Sprite(image,self.pos[0], self.pos[1], batch=batch, group=group)
        
    def update(self):
        self.vel[1]+=self.gravity
        self.vel[0]*=0.95
        self.vel[1]*=0.95
        self.pos=[self.pos[0]+self.vel[0],self.pos[1]+self.vel[1]]
        self.sprite.x=int(self.pos[0]-7)
        self.sprite.y=int(self.pos[1]-4)

           
    def shift(self,y):
        self.pos[1]+=y

    def reset(self):
        pass

class controls:
    def __init__(self,fansize,batch,group):
        self.pos=[320,240]
        self.rad=[120,fansize]
        self.vertex_list = batch.add(4,pyglet.gl.GL_POLYGON,group,
                            ('v2f', toVert(self.pos,self.rad)),
                            ('c4B', (128, 128, 128,225)*4))
        
    def update(self):
        self.vertex_list.vertices=toVert(self.pos,self.rad)

    def draw(self):
        pass
        #self.vertex_list.draw(pyglet.gl.GL_POLYGON)



class tile:
    def shift(self, y,vis):
        self.pos[1]+=y
        if vis==1:
            self.sprite.y+=y
        elif vis==0:
            self.sprite.y=self.pos[1]-15    
    def update(self):
        pass
class grav(tile):
    
    def __init__(self,batch,group,off,x,y,image):
        self.deadly=False
        self.grav=True
        self.used=False
        self.pos=list(toGrid(x,y))
        self.pos[1]+=off-480
        self.sprite=pyglet.sprite.Sprite(image,self.pos[0]-15, self.pos[1]-15, batch=batch, group=group)
        


class block(tile):
    
    def __init__(self,batch,group,off,x,y,image):
        self.deadly=True
        self.used=False
        self.pos=list(toGrid(x,y))
        self.pos[1]+=off-480
        self.sprite=pyglet.sprite.Sprite(image,self.pos[0]-15, self.pos[1]-15, batch=batch, group=group)

class mover(tile):
    
    def __init__(self,batch,group,off,x,y,image):
        self.deadly=True
        self.used=False
        self.pos=list(toGrid(x,y))
        self.pos[1]+=off-480
        self.oldx=self.pos[0]
        self.direction=1
        self.sprite=pyglet.sprite.Sprite(image,self.pos[0]-15, self.pos[1]-15, batch=batch, group=group)
        
    def update(self):
        if self.pos[0]-self.oldx in (30,-30):
            self.direction*=-1
        self.pos[0]+=self.direction
        self.sprite.x+=self.direction
        
class fake(tile):
    
    def __init__(self,batch,group,off,x,y,image):
        self.deadly=False
        self.used=False
        self.pos=list(toGrid(x,y))
        self.pos[1]+=off-480
        self.sprite=pyglet.sprite.Sprite(image,self.pos[0]-15, self.pos[1]-15, batch=batch, group=group)

            
class check(tile):
    
    def __init__(self,batch,group,off,x,y,image):
        self.deadly=False
        self.used=False
        self.reset=True
        self.pos=list(toGrid(x,y))
        self.pos[1]+=off-480
        self.sprite=pyglet.sprite.Sprite(image,self.pos[0]-15, self.pos[1]-15, batch=batch, group=group)
        
class fan(tile):
    def __init__(self,batch,group,off,x,y,dir,image):
        self.deadly=False
        self.pos=list(toGrid(x,y))
        self.pos[1]+=off-480
        self.dir=dir
        self.used=False
        self.sprite=pyglet.sprite.Sprite(image,self.pos[0]-15, self.pos[1]-15, batch=batch, group=group)
        
    def blow(self,f):
        info=(
            (0,0.2),
            (1,0.15-f.gravity),
            (0,-0.2),
            (1,-0.15-f.gravity))
        f.vel[info[self.dir][0]]+=info[self.dir][1]
        











#Large class to handle all the game managment
class level:
    def __init__(self):
        self.tiles=[[[] for y in range(16*15)] for x in range(10)]
        self.faketiles=[[[] for y in range(16*15)] for x in range(10)]
        self.player=pyglet.media.Player()
        self.candie=True
        self.fimg=pyglet.image.load(data.filepath("sprites/feather.png"))
        self.fimg2=pyglet.image.load(data.filepath("sprites/feather2.png"))
        self.fimg3=pyglet.image.load(data.filepath("sprites/feather3.png"))
        
        self.text="Test"
        self.died=False
        self.started=False
        self.batch =pyglet.graphics.Batch()
        
        
    
        self.backdrop= pyglet.graphics.OrderedGroup(1)
        self.lightscape= pyglet.graphics.OrderedGroup(2)
        self.fanscape= pyglet.graphics.OrderedGroup(3)
        self.foreground= pyglet.graphics.OrderedGroup(4)
        self.feth= pyglet.graphics.OrderedGroup(5)
        self.c=controls(30,self.batch, self.fanscape)
        
        self.light=pyglet.sprite.Sprite(pyglet.image.load(data.filepath("sprites/light.png")),-99,-99, batch=self.batch, group=self.lightscape)
        self.bird=pyglet.sprite.Sprite(pyglet.image.load(data.filepath("sprites/bird.png")),240,-99, batch=self.batch, group=self.backdrop)
        
        #FIX ME
        self.up=pyglet.image.load(data.filepath("sprites/up.png"))
        self.down=pyglet.image.load(data.filepath("sprites/down.png"))
        self.left=pyglet.image.load(data.filepath("sprites/left.png"))
        self.right=pyglet.image.load(data.filepath("sprites/right.png"))
        self.blockimg=image=pyglet.image.load(data.filepath("sprites/block.png"))
        self.check=pyglet.image.load(data.filepath("sprites/check.png"))
        
        self.grav=pyglet.image.load(data.filepath("sprites/gravity.png"))
        self.dirs=[self.right,self.up,self.left,self.down]
        self.resetwav = pyglet.media.load(data.filepath('sounds/reset.wav'), streaming=False)
        self.diewav = pyglet.media.load(data.filepath('sounds/splode.wav'), streaming=False)
        self.gravwav = pyglet.media.load(data.filepath('sounds/gravity.wav'), streaming=False)
        self.backgroundmusic= pyglet.media.load(data.filepath('sounds/menumusic.mp3'), streaming=True)
        
        
        



    def update(self):
        #update feather
        self.f.update()
        #hit a wall
        self.light.x=int(self.f.pos[0]-100+self.f.dir*4)
        self.light.y=int(self.f.pos[1]-100)
        if not 200+self.f.rad[0]<self.f.pos[0]<440-self.f.rad[0]:
            self.died+=True
        #or a block
        else:
            genoff=int((self.off-self.f.pos[1])/30)+1
            for x in self.tiles:
                for y in x:
                    if y: y.update()
            for x in self.tiles:
                for y in x[genoff-2:genoff+2]:
                    if y: 
                        if collide(self.f,y):
                            if y.deadly:
                                self.died+=True
                            elif hasattr(y,"blow"):
                                y.blow(self.f)
                            elif hasattr(y,"grav"):
                                if not y.used:
                                    self.f.gravity*=-1
                                    y.used=True
                                    self.gravwav.play()
                                
                            elif hasattr(y,"reset"):
                                if y.pos!=self.reset:
                                    self.resetwav.play()
                                    self.reset=y.pos[:]
                                    file=open(data.filepath("save.txt"),'w')
                                    file.writelines(
                                        [str(x)+'\n' for x in self.highestlevel,
                                        self.reset[0],
                                        self.reset[1],
                                        self.off])
                                    file.close()
                                    
                        else: y.used=False
                            
                            
        if self.died and self.candie:
            self.f.pos=self.reset[:]
            self.f.vel=[0,0]
            self.died=False
            self.diewav.play()
            self.shift(240-self.reset[1],True)
            self.shift(0)
            
                
        self.c.update()
        
        
        
        
    def draw(self):
        pyglet.graphics.draw(4, pyglet.gl.GL_POLYGON,
        ('v2i', (200, 0, 200, 480,440,480,440,0)),('c3B', (255, 255, 255)*4))
        #MOVE ALLL TO BATCH
        
        
        self.batch.draw()
        pyglet.graphics.draw(4, pyglet.gl.GL_POLYGON,
        ('v2i', (0, 0, 0, 480,200,480,200,0)),('c3B', (0, 0, 0)*4))
        pyglet.graphics.draw(4, pyglet.gl.GL_POLYGON,
        ('v2i', (440, 0, 440, 480,640,480,640,0)),('c3B', (0, 0, 0)*4))
    
    
    
    
    
    def blow(self,dir):
        cy=self.c.pos[1]
        ry=self.c.rad[1]
        fy=self.f.pos[1]
        if -ry<=fy-cy<=ry:
            self.f.vel[0]+=dir
            if dir>0:
                self.f.dir=dir
                self.f.sprite.image=self.f.img2
            else:
                self.f.dir=dir
                self.f.sprite.image=self.f.img
    
    
    
    
    def shift(self,dy,snap=False):
        self.f.shift(dy)
        self.reset[1]+=dy
        self.bird.y+=dy
        tilesoff=(self.off//30)-16
        
        if (tilesoff)+21>self.highestlevel*16:
            self.highestlevel+=1
            self.addLevel(self.highestlevel)
        
        #make tiles visible and in place
        for x in range(len(self.tiles)):
            for y in range(len(self.tiles[x])):
                if self.tiles[x][y]:
                    if y<(tilesoff)-50+16:
                        self.tiles[x][y]=[]
                    elif (tilesoff)-1<y<(tilesoff)+18:
                        if snap:
                            self.tiles[x][y].shift(dy,0)
                        else:
                            self.tiles[x][y].shift(dy,1)
                        self.tiles[x][y].sprite.visible=True
                    elif y in ((tilesoff)-2,(tilesoff)-1,(tilesoff)+18,(tilesoff)+19):    
                        self.tiles[x][y].shift(dy,0)
                        self.tiles[x][y].sprite.visible=False
                    else:
                        if snap:
                            self.tiles[x][y].shift(dy,0)
                            self.tiles[x][y].sprite.visible=False
                        else:
                            self.tiles[x][y].shift(dy,-1)
                if self.faketiles[x][y]:
                    if y<(tilesoff)-50+16:
                        self.faketiles[x][y]=[]
                    elif (tilesoff)-1<y<(tilesoff)+18:
                        if snap:
                            self.faketiles[x][y].shift(dy,0)
                        else:
                            self.faketiles[x][y].shift(dy,1)
                        self.faketiles[x][y].sprite.visible=True
                    elif y in ((tilesoff)-2,(tilesoff)-1,(tilesoff)+18,(tilesoff)+19):    
                        self.faketiles[x][y].shift(dy,0)
                        self.faketiles[x][y].sprite.visible=False
                    else:
                        if snap:
                            self.faketiles[x][y].shift(dy,0)
                            self.faketiles[x][y].sprite.visible=False
                        else:
                            self.faketiles[x][y].shift(dy,-1)
        self.off+=dy                
    
    
    
    
                            
    def loadLevel(self,levelno):
        filename=data.filepath("levels/level"+str(levelno)+".txt")
        tiles=[]
        faketiles=[]
        blocks={
        "0":(fake,  (self.blockimg,)),
        "1":(block, (self.blockimg,)),
        ">":(fan,   (0,self.dirs[0])),
        "^":(fan,   (1,self.dirs[1])),
        "<":(fan,   (2,self.dirs[2])),
        "v":(fan,   (3,self.dirs[3])),
        "V":(fan,   (3,self.dirs[3])),
        "m":(mover, (self.blockimg,)),
        "M":(mover, (self.blockimg,)),
        "r":(check,    (self.check,)),
        "R":(check,    (self.check,)),
        "g":(grav,      (self.grav,)),
        "G":(grav,      (self.grav,))}
        
        file=open(filename,"r")
        file.readline()
        off=(levelno-1)*16
        for i in range(1,16+1):
            line = file.readline()
            for j in range(len(line)):
                for key in "01><v^rRgGmMV":
                    if line[j]==key:
                        if key in "0RGMV":
                            faketiles.append((j+1,i+off,self.backdrop,blocks["0"][0],blocks["0"][1]))
                        if key!="0":
                            tiles.append((j+1,i+off,self.foreground,blocks[key][0],blocks[key][1]))
        file.close()
        try:
            file=open(data.filepath("guides/level"+str(levelno)+".txt"),"r")
            try:
                self.text="\n".join(file.readlines())
            except:
                pass
            finally:
                file.close()
        except:
            pass
        return tiles,faketiles
    
    
        
    def addLevel(self,levelno):
        details,fakes=self.loadLevel(levelno)
        for (x,y,group,clas,args) in details:
            self.tiles[x][y]=clas(self.batch,group,self.off,x,y,*args)
        
        for (x,y,group,clas,args) in fakes:
            self.faketiles[x][y]=clas(self.batch,group,self.off,x,y,*args)
    def newGame(self,new=False):
        if not os.path.exists(data.filepath("save.txt")) or new:
            self.highestlevel=1
            self.reset=[320,480]
            self.off=480
            
        else:
            file=open(data.filepath("save.txt"))
            self.reset=[0,0]
            self.highestlevel=int(file.readline())
            self.reset[0]=int(file.readline())
            self.reset[1]=int(file.readline())
            self.off=int(file.readline())
            file.close()
        
        self.f=feather(self.batch, self.feth,self.fimg,self.fimg2,self.reset[:])
        self.shift(240-self.reset[1],True)
        for x in range(self.highestlevel+1):
            if x: self.addLevel(x)
        self.menmucon.stop()
        
        self.player.queue(pyglet.media.load(data.filepath('sounds/gamemusic.mp3'), streaming=True))
        self.player.eos_action='loop'
        self.player.play()
        self.bird.y=int(-30*16*12 + 30 + self.off)
        
        
        
        
        
        
        
        
        
menufocus="start "
        
def main():
    l=level()
    menufocus="start "
    window = pyglet.window.Window(width=640, height=480,caption="Featherbound")
    
    pyglet.font.add_file(data.filepath('prstartk.ttf'))
    PrStart = pyglet.font.load('Press Start K')
    
    title = pyglet.text.Label('Featherbound',
                          font_size=36,
                          x=window.width//2, y=window.height//2+180,
                          anchor_x='center', anchor_y='center', font_name='Press Start K')
    start = pyglet.text.Label('Start',
                          font_size=24,
                          x=window.width//2, y=window.height//2+60,
                          anchor_x='center', anchor_y='center', font_name='Press Start K')
    reset = pyglet.text.Label('Reset Game',
                          font_size=24,
                          x=window.width//2, y=window.height//2,
                          anchor_x='center', anchor_y='center', font_name='Press Start K')
    quit = pyglet.text.Label('Quit',
                          font_size=24,
                          x=window.width//2, y=window.height//2-60,
                          anchor_x='center', anchor_y='center', font_name='Press Start K')
    guide=pyglet.text.Label('',
                          font_size=8,
                          x=540, y=window.height//2,multiline=True,width=180,
                          anchor_x='center', anchor_y='center', font_name='Press Start K')
    menu={"start ":(reset,"reset game  "),"reset game  ":(quit,"quit "),"quit ":(start,"start ")}
    labelfocus=start
    menustar=pyglet.sprite.Sprite(l.fimg3,start.x+6*14,start.y-8)
    l.menmucon=l.backgroundmusic.play()
    
    
    @window.event
    def on_key_press(symbol, modifiers):
        global menufocus
        if symbol==key.ENTER:
            if menufocus=="start ":
                l.started=True
                l.newGame()
            elif menufocus=="reset game  ":
                l.started=True
                l.newGame(True)
            elif menufocus=="quit ":
                pyglet.app.exit()
            else: print menufocus
        elif symbol==key.UP:
            labelfoucs,menufocus=menu[menufocus]
            labelfocus,menufocus=menu[menufocus]
            menustar.x=labelfocus.x+len(menufocus)*14
            menustar.y=labelfocus.y-8
        elif symbol==key.DOWN:
            labelfocus,menufocus=menu[menufocus]
            menustar.x=labelfocus.x+len(menufocus)*14
            menustar.y=labelfocus.y-8
        return pyglet.event.EVENT_UNHANDLED
    keys = key.KeyStateHandler()
    window.push_handlers(keys)
    
    glEnable(GL_BLEND)
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)

    @window.event
    def on_draw():
        window.clear()
        if l.started:
            l.draw()
            
            guide.draw()
        else:
            for x in (title,start,reset,quit,menustar):
                x.draw()
            
        
        
        
    def update(dt):
        #FIX refactor
        
        
        if l.started:        
            if keys[key.UP]:
                l.shift(-2)
                if not l.candie:
                    l.candie=True
                    l.died=False
            if keys[key.DOWN]:
                l.shift(2)
            if keys[key.RIGHT]:
                l.blow(0.4)
            if keys[key.LEFT]:
                l.blow(-0.4)
            if keys[key.Z]:
                l.f.vel[1]-=0.3
                l.candie=False
            l.update()
            if guide.text!=l.text:
                guide.text=l.text


    pyglet.clock.schedule_interval(update, 1/30.0)


    pyglet.app.run()


if __name__=="__main__":

    main()
    
